clear all;
close all;

global n;
global p;
global k;
global q;
global p_l;
global comb_l;


global z_hat_0;
global x_0;
global x_hat_0;

global C;
global C_local;
global A;
global A_stack;
global A_obs;
global L_stack;
global Phi;
global gamma_stack;
global adjacency_stack;
global Laplacian_stack;


global lambda;
global noise_threshold;
global constant_threshold;
global selection_l;
global Phi_selection;
global Phi_selection_inv;

global Ts;
global samp;

k=10;
%k=5;
n=2*k;
p=6*k;


q=2;
A_l = int32(n/k);
p_l = int32(p/k);
comb_l = nchoosek(p_l,p_l-q);
selection_l = combnk(1:p_l,p_l-q);


C_local = [1 0 1/sqrt(2) 1/sqrt(2) 2/sqrt(5) 1/sqrt(5);
           0 1 1/sqrt(2) -1/sqrt(2) 1/sqrt(5) -2/sqrt(5)]';
C = kron(eye(k),C_local);



Phi_selection = zeros(p_l-q,A_l,comb_l);
Phi_selection_inv = zeros(A_l,p_l-q,comb_l);
for i = 1:comb_l
    Phi_selection(:,:,i) = C_local(selection_l(i,:),:);
    Phi_selection_inv(:,:,i) = pinv(Phi_selection(:,:,i));
end


I_p = eye(p);
w = rand(k,1)*0.1+0.05;
w_diag = diag(w);
A = kron(-w_diag,eye(A_l));
A_obs = kron(eye(p_l),-w_diag);
A_stack = kron(eye(p),A);
gamma = rand(p,1)*p+10+p^2;
gamma_stack = kron(diag(gamma),eye(n));

theta = rand(p,1)*(-3)-2;
z_hat_0 = rand(p,1)*10*sqrt(2)-5*sqrt(2);
x_0 = rand(n,1)*10-5;
x_hat_0 = rand(n*p,1)*10-5;
L_stack = -diag(theta) - kron(w_diag,eye(p_l));

temp3 = eye(p,p+1);
temp3(1,p+1)=1;
adjacency = temp3(:,2:p+1);
adjacency_stack = kron(adjacency,eye(n));
Laplacian = eye(p)-adjacency;
Laplacian_stack = kron(Laplacian,eye(n));

temp4 = eye(p);
Phi = kron(temp4(1,:), C(1,:));

for i = 2:p
   Phi = cat(1,Phi,  kron(temp4(i,:), C(i,:)));
end


Ts = 0.001;
noise_power = 0.0001;
noise_seed = randi(10000,p,1);

lambda = -2;
noise_threshold = 0.1;
constant_threshold = 30*sqrt(2);


%attack signal parameters
attack_amp = 1;
attack_period = 0.4;
attack_pulse = 50;

attack_time1 = 8;
attack_duration1 = 3;
attack_time2 = 16;

attack_time3 = 10;

samp = randi(comb_l,k,1);

